/*
 * @COPYRIGHT@
 *
 * Scout Version 1.0
 * 
 * Copyright 1998 Arizona Board of Regents, on behalf of
 *         The University of Arizona
 *         All Rights Reserved
 *
 *
 *                        Copyright (c) 1987 Bellcore
 *                            All Rights Reserved
 *       Permission is granted to copy or use this program, EXCEPT that it
 *       may not be sold for profit, the copyright notice must be reproduced
 *       on copies, and credit should be given to Bellcore where it is due.
 *       BELLCORE MAKES NO WARRANTY AND ACCEPTS NO LIABILITY FOR THIS PROGRAM.
 *
 * @COPYRIGHT@
 *
 * $\RCSfile: font.h,v $
 *
 * HISTORY
 * $\Log: font.h,v $
 * Revision 1.3  1998/01/31 18:43:08  mjk
 * replaced copyright
 *
 * Revision 1.2  1998/01/28 18:23:56  mjk
 * copyright
 *
 * Revision 1.1  1997/04/15 18:15:49  acb
 * Initial revision
 *
 * Revision 1.1  1997/03/25 22:19:39  acb
 * Initial revision
 *
 * Revision 1.1  1997/03/12 18:01:14  acb
 * Initial revision
 *
 * Revision 1.1  1996/12/19  21:12:41  acb
 * * Eliminated most global variables
 * * Rlogin windows can be created from menu
 * * 'Destroy window' and 'quit' menu options work now
 * * Moved location of header files
 * * Many small display glitches fixed
 *
 */


#ifndef _MGR_FONT_H
#define _MGR_FONT_H

/* Constant spaced font format */

#define FONT_X '\026' /* fixed width fonts 16 bit alignment (obsolete) */
#define FONT_S '\027' /* fixed width static 32 bit alignment */
#define FONT_A '\030' /* fixed width fonts 32 bit alignment*/
#define FONT_P '\031' /* (not used yet) proportional fonts */
#define FONT_U '\025' /* (unused) 16-bit wide char, proportional fonts */
#define FONT_G '\024' /* (unused) gray-scale, antialiased fonts */

struct font_header
{
   unsigned char type;		/* font type */
   unsigned char wide;		/* character width */
   unsigned char high;		/* char height */
   unsigned char baseline;	/* pixels from bottom */
   unsigned char count;		/* number of chars in font */
   unsigned char start;		/* starting char in font */
};

#endif
/*{{{}}}*/
